# frozen_string_literal: true

module ActiveSwagger
  module Definitions
    @registry = {}

    def self.registry
      @registry
    end

    def self.add_to_registry(klass, key, name, options = nil)
      set_default_values(klass, key)

      if options.blank?
        registry[klass.to_s][key] = name
      else
        registry[klass.to_s][key].merge!({ name => options }) unless options.blank?
      end
    end

    def self.set_default_values(klass, key)
      registry[klass.to_s] ||= {}
      registry[klass.to_s][key] ||= {}
    end

    def self.add_swagger_atribute(klass, name, options = {})
      options[:type] ||= :string
      options[:type] ||= klass.columns.find { |c| c.name == name.to_s }.sql_type_metadata.type

      add_to_registry(klass, :schema_attributes, name, options)
    end
  end
end
