# frozen_string_literal: true

module ActiveSwagger
  class Params
    attr_accessor :properties

    def initialize(properties)
      @properties = properties
    end

    def mapping(key, value)
      case value[:type]
      when :array
        { key => [] }
      when :object
        { key => {} }
      else
        key
      end
    end

    def to_strong_params
      params = []
      properties.each_pair do |key, value|
        params.push(mapping(key, value))
      end
      params
    end
  end
end
